#include <iostream>
#include<vector>
using namespace std;

int main()
{
    int N,Q,n;
    vector<int> pai={};
   vector<char> betuk={};
   cin>>N;
   cin>>Q;
   for(int i=0;i<N;i++){
    cin>>n;
    betuk.push_back(n);
   }
   int a;
   int b;
   for(int i=0;i<Q;i++){
   cin >>a;
   cin>>b;
   pai.push_back(a);
   pai.push_back(a);
   }
   int q;
   for(int i=1;i<Q+1;i++){
   q=pai[i]-pai[i-1];
   if(q%2==0){
    cout<<(q/2)*(q/2);
   }
   else{
    cout<<int(q/2)+1;
   }
   }
    return 0;
}